// basinCellNR.cc

//----------------------------------------------------------------------
//	BasinCellNR		$B%;%kFbIt$N7W;;$r$9$k%/%i%9(B
//----------------------------------------------------------------------

#include "basinCellNR.h"	// $B%/%i%9(B BasinCellNR $B$NDj5A(B

Boolean BasinCellNR::Connect_segment(FILE* fp)
{
	int i, j, k, l;
	char str[1024];

	//	$B?^3TFb$N2OF;6hJ,$N@\B34X78$K4X$9$kItJ,(B

	if (fgets(str, 1024, fp) != NULL) {
		if (sscanf(str, "%d", &n_node) != 1) return NO;
		if (n_node < 0) return NO;
		nt = new NodeType[n_node];
		for (i = 0; i < n_node; i++) {
			if (fgets(str, 1024, fp) != NULL) {
				if (sscanf(str, "%d %d", &j, &k) != 2) return NO;
				nt[i].nodenumber = j;
				nt[i].attribute = k;
				if (k < 0 || k > 4) return NO;
			}
			else return NO;
		}
	}
	else return NO;

	if (fgets(str, 1024, fp) != NULL) {
		if (sscanf(str, "%d", &n_seg) != 1) return NO;
		if (n_seg < 0) return NO;
		seg = new SegmentNR[n_seg];
		pv = new PositionOfVariable[n_seg];
		for (i = 0; i < n_seg; i++) {
			if (fgets(str, 1024, fp) != NULL) {
				if (sscanf(str, "%d %d %d", &j, &k, &l) != 3) return NO;
				if (seg[i].Init(j, k, l) != YES) return NO;
			}
			else return NO;
		}
	}
	else return NO;

	n_tan = 0;
	n_ur = 0;
	n_lr1 = 0;
	n_lr2 = 0;

	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute != 0) {	// $B?^3TFbJ,9gN.E@$G$J$1$l$P%+%&%s%H(B
			n_tan = n_tan + 1;
		}
		if (nt[i].attribute == 2) {	// $B:G>eN.C<$G$"$l$P%+%&%s%H(B
			n_ur = n_ur + 1;
		}
		else if (nt[i].attribute == 3) {	// $B:G2<N.C<(B 1 $B$G$"$l$P%+%&%s%H(B
			n_lr1 = n_lr1 + 1;
		}
		else if (nt[i].attribute == 4) {	// $B:G2<N.C<(B 2 $B$G$"$l$P%+%&%s%H(B
			n_lr2 = n_lr2 + 1;
		}
	}

	n_cnfl = n_node - n_tan;
	cnfl = new Confluence[n_cnfl];

	k = l = 0;
	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute == 0) {		// $B?^3TFbJ,9gN.E@$N;~(B
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Upnode(nt[i].nodenumber) == YES ||
					seg[j].Lownode(nt[i].nodenumber) == YES) {
					l++;
				}
			}
			cnfl[k].nodesum = l;
			(cnfl[k].segnum).Resize(l);
			k++;
			l = 0;
		}
	}

	k = l = 0;
	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute == 0) {		// $B?^3TFbJ,9gN.E@$N;~(B
			cnfl[k].nodenum = nt[i].nodenumber;
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Upnode(nt[i].nodenumber) == YES) {
					cnfl[k].segnum[l] = - seg[j].Re_segnum();
					l++;								// $BN.=P$OIi(B
				}
				else if (seg[j].Lownode(nt[i].nodenumber) == YES) {
					cnfl[k].segnum[l] = seg[j].Re_segnum();
					l++;								// $BN.F~$O@5(B
				}
			}
			k++;
			l = 0;
		}
	}
	return YES;
}

Boolean BasinCellNR::Set_position_of_variable(void)
{
	int i, j;
	Boolean flag;

	for (i = 0; i < n_seg; i++) {
		pv[i].segnum = seg[i].Re_segnum();
		pv[i].upposition = 9999;
		pv[i].lowposition = 9999;
	}

	for (i = 0; i < n_tan; i++) {
		if (d_node[2 * i][1] == 0) {
			flag = NO;
			for (j = 0; j < n_seg; j++) {
				if (pv[j].segnum == d_node[2 * i][0]) {
					flag = YES; break;
				}
			}
			if (flag == NO) return NO;
			pv[j].upposition = 2 * i;
		}
		if (d_node[2 * i][1] == 2) {
			flag = NO;
			for (j = 0; j < n_seg; j++) {
				if (pv[j].segnum == d_node[2 * i][0]) {
					flag = YES; break;
				}
			}
			if (flag == NO) return NO;
			pv[j].lowposition = 2 * i;
		}
	}

	return YES;
}

Boolean BasinCellNR::Set_parameter(FILE* fp, time_t time_step)
{
	int i, j, k, l, m;
	Boolean* tan_flag;
	Boolean flag;
	char str[1024];

	// 	$B<+J,<+?H$N%Q%i%a%?$N@_Dj(B

	M_node = new double*[n_seg * 4 - n_tan];
	d_node = new int*[n_seg * 4];
	for (i = 0; i < n_seg * 4 - n_tan; i++) {
		M_node[i] = new double[n_seg * 4];
	}
	for (i = 0; i < n_seg * 4; i++) {
		d_node[i] = new int[2];
	}
	F_node.Resize(n_seg * 4 - n_tan);

	// $B9TNs$NJB$SJQ$($N$?$a$N=`Hw(B

	tan_flag = new Boolean[n_seg * 2];	// $B7W;;C<E@$+H]$+$N%U%i%0(B

	for (i = 0; i < n_seg * 2; i++) {
		tan_flag[i] = YES;
	}

	for (i = 0; i < n_seg; i++) {
		j = seg[i].Re_upnode();
		flag = NO;
		for (k = 0; k < n_node; k++) {
			if (nt[k].nodenumber == j) {
				flag = YES; break;
			}
		}
		if (flag == YES) {
			if (nt[k].attribute == 0) tan_flag[2 * i] = NO;
		}
		else return NO;
		j = seg[i].Re_lownode();
		flag = NO;
		for (k = 0; k < n_node; k++) {
			if (nt[k].nodenumber == j) {
				flag = YES; break;
			}
		}
		if (flag == YES) {
			if (nt[k].attribute == 0) tan_flag[2 * i + 1] = NO;
		}
		else return NO;
	}

	j = 0;
	for (i = 0; i < n_tan; i++) {
		if (tan_flag[i] == NO) j++;
	}

	n_change = j;
	v_array = new int*[n_change];
	for (i = 0; i < n_change; i++) {
		v_array[i] = new int[2];
	}

	k = 0;
	for (i = 0; i < n_tan; i++) {			// $B9TNs$NJB$SJQ$((B
		if (tan_flag[i] == NO) {
			for (j = n_seg * 2 - 1; j > n_tan - 1; j--) {
				if (tan_flag[j] == YES) break;
			}
			v_array[k][0] = i;
			v_array[k][1] = j;
			tan_flag[i] = YES;
			tan_flag[j] = NO;
			k++;
		}
	}

	delete [] tan_flag;
	if (k != n_change) return NO;

	for (i = 0; i < n_seg; i++) {				// $BL$CNNL$N=gHV(B
		j = seg[i].Re_segnum();
		d_node[4 * i][0] = j;
		d_node[4 * i][1] = 0;
		d_node[4 * i + 1][0] = j;
		d_node[4 * i + 1][1] = 1;
		d_node[4 * i + 2][0] = j;
		d_node[4 * i + 2][1] = 2;
		d_node[4 * i + 3][0] = j;
		d_node[4 * i + 3][1] = 3;
	}

	for (i = 0; i < n_change; i++) {			// $B9TNs$NJB$SJQ$((B
		j = v_array[i][0];
		k = v_array[i][1];
		for (l = 0; l < 2; l++) {		// $BL$CNNL$N8r49(B
			m = d_node[2 * j][l];
			d_node[2 * j][l] = d_node[2 * k][l];
			d_node[2 * k][l] = m;
			m = d_node[2 * j + 1][l];
			d_node[2 * j + 1][l] = d_node[2 * k + 1][l];
			d_node[2 * k + 1][l] = m;
		}
	}

	pv = new PositionOfVariable[n_seg];
	if (Set_position_of_variable() != YES) return NO;

	for (i = 0; i < n_seg; i++) {
		if (fgets(str, 1024, fp) != NULL) {
			if (sscanf(str, "%d", &j) != 1) return NO;
			flag = NO;
			for (k = 0; k < n_seg; k++) {
				if (j == seg[k].Re_segnum()) {
					flag = YES; break;
				}
			}
			if (flag == NO) return NO;
			if (seg[k].Set_parameter(fp, time_step) != YES) return NO;
		}
		else return NO;
	}

	// $B3F2OF;6hJ,$N2OF;D9$NAmOB(B L_sum $B$r7W;;$9$k(B

	L_sum = 0.;
	for (i = 0; i < n_seg; i++) {
		L_sum = L_sum + seg[i].Re_length();
	}

	Qflag = NO;
	Hflag = NO;

	return YES;
}

Boolean BasinCellNR::Set_init_for_varied(FILE* fp)
{
	// $BITEyN.$N7W;;$N$?$a$N=i4|>uBVNL$r@_Dj$7$^$9!#(B

	int i, j, k, l;
	double qup, qlat;
	char str[1024];
	Boolean flag;

	for (i = 0; i < n_seg; i++) {
		if (fgets(str, 1024, fp) != NULL) {
			if (sscanf(str, "%d %lf %lf", &j, &qup, &qlat) == 3) {
				flag = NO;
				for (k = 0; k < n_seg; k++) {
					if (j == seg[k].Re_segnum()) {
						flag = YES; break;
					}
				}
				if (flag == NO) return NO;
				j = seg[k].Re_upnode();
				for (l = 0; l < n_node; l++) {
					if (nt[l].nodenumber == j) break;
				}
				if (nt[l].attribute != 2) return NO;	// $B>eN.C<6-3&$G(B
														// $B$J$1$l$P%"%&%H(B
				seg[k].Set_init_for_varied(qup, qlat);
			}
			else if(sscanf(str, "%d %lf", &j, &qlat) == 2) {
				flag = NO;
				for (k = 0; k < n_seg; k++) {
					if (j == seg[k].Re_segnum()) {
						flag = YES; break;
					}
				}
				if (flag == NO) return NO;
				j = seg[k].Re_upnode();
				for (l = 0; l < n_node; l++) {
					if (nt[l].nodenumber == j) break;
				}
				if (nt[l].attribute == 2) return NO;	// $B>eN.C<6-3&$G(B
														// $B$"$l$P%"%&%H(B
				seg[k].Set_init_for_varied(qlat);
			}
			else return NO;
		}
		else return NO;
	}
	return YES;
}

Boolean BasinCellNR::Set_init_for_runoff(FILE* fp, double lat)
{
	int i, j, k;
	double l;
	char str[1024];
	Boolean flag;

	l = lat / L_sum;

	for (i = 0; i < n_seg; i++) {
		if (fgets(str, 1024, fp) != NULL) {
			if (sscanf(str, "%d", &j) != 1) return NO;
			flag = NO;
			for (k = 0; k < n_seg; k++) {
				if (j == seg[k].Re_segnum()) {
					flag = YES; break;
				}
			}
			if (flag == NO) return NO;
			if (seg[k].Set_init_for_runoff(fp, l) != YES) return NO;
		}
		else return NO;
	}
	return YES;
}

Boolean BasinCellNR::Save_terminal_state(FILE* fp)
{
	int i, j;

	if (fp == NULL) return NO;
	for (i = 0; i < n_seg; i++) {
		j = seg[i].Re_segnum();
		fprintf(fp, "%d\n", j);
		if (seg[i].Save_terminal_state(fp) != YES)	return NO;
	}
	return YES;
}

void BasinCellNR::Re_lowest_q(Vdary& Qlr)
{
	int i, j, k;

	if (Qlr.Size() != (n_lr1 + n_lr2)) {
		printf("Cannot return lowest discharge.\n");
		printf("BasinCellNR::Re_lowest_q\n");
		exit(1);
	}
		
	k = 0;

	for (i = 0; i < n_node; i++) {				// $B2<N.C<6-3&$N;~(B
		if (nt[i].attribute == 3 || nt[i].attribute == 4) {
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Lownode(nt[i].nodenumber) == YES) break;
			}
			Qlr[k] = seg[j].Re_node_variable(LOWER, DISCHARGE,
											 CURRENT);
			k++;
		}
	}
}

void BasinCellNR::Ready_for_calculate(double lat, Vdary qup, Vdary hlow)
{
	/* $B3F2OF;$GO"N)J}Dx<0$r$?$F$k$?$a$N=`Hw(B($B3F%9%F%C%W$N7W;;3+;O;~$K$N$_(B
	   $B8F$P$l$k(B) */

	int i, j, k, l;

	if (qup.Size() != n_ur || hlow.Size() != n_lr1) {
		printf("Cannot ready calculation.\n");
		printf("BasinCellNR::Ready_for_calculate\n");
		exit(1);
	}

	// $BN.NL!&?e?<5Z$SB&J}N.F~NL$N=i4|$N?dDjCM$r@_Dj$9$k(B

	lat = lat / L_sum;

	for (i = 0; i < n_seg; i++) {
		seg[i].First_estimation(lat);
	}

	k = 0;

	for (i = 0; i < n_node; i++) {	// $B>eN.C<$GN.NL$r<hF@(B
		if (nt[i].attribute == 2) {
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Upnode(nt[i].nodenumber) == YES) break;
			}
			seg[j].Set_upper_condition(qup[k]);
			k++;
		}
	}

	l = 0;

	for (i = 0; i < n_node; i++) {	// $B2<N.C<$G?e0L$r<hF@(B
		if (nt[i].attribute == 3) {
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Lownode(nt[i].nodenumber) == YES) break;
			}
			seg[j].Set_lower_condition(hlow[k]);
			l++;
		}
	}

	if (k != n_ur || l != n_lr1) {
		printf("Cannot ready calculation.\n");
		printf("BasinCellNR::Ready_for_calculate\n");
		exit(1);
	}
}

Boolean BasinCellNR::Make_equation(time_t time_step)
{
	int i, j, k, l, m, ll, mm;
	double** c;

	//	$B%N!<%I$N$_$NO"N)J}Dx<0$r$?$F$k(B

	for (i = 0; i < n_seg * 4 - n_tan; i++) {	// $B9TNs$N=i4|2=(B
		F_node[i] = 0.;
		for (j = 0; j < n_seg * 4; j++) {
			M_node[i][j] = 0.;
		}
	}

	for (i = 0; i < n_seg; i++) {				// $BL$CNNL$N=gHV(B
		j = seg[i].Re_segnum();
		d_node[4 * i][0] = j;
		d_node[4 * i][1] = 0;
		d_node[4 * i + 1][0] = j;
		d_node[4 * i + 1][1] = 1;
		d_node[4 * i + 2][0] = j;
		d_node[4 * i + 2][1] = 2;
		d_node[4 * i + 3][0] = j;
		d_node[4 * i + 3][1] = 3;
	}

	c = new double*[2];
	for (i = 0; i < 2; i++) {
		c[i] = new double[3];
	}

	for (i = 0; i < n_seg; i++) {				// $B3F2OF;$K4X$9$kItJ,(B
		seg[i].Make_equation(time_step);
		if (seg[i].Sweep_equation(c) != YES) return NO;

		M_node[2 * i][4 * i] = c[0][0];
		M_node[2 * i][4 * i + 1] = c[0][1];
		M_node[2 * i][4 * i + 2] = 1.;
		M_node[2 * i + 1][4 * i] = c[1][0];
		M_node[2 * i + 1][4 * i + 1] = c[1][1];
		M_node[2 * i + 1][4 * i + 3] = 1.;
		F_node[2 * i] = c[0][2];
		F_node[2 * i + 1] = c[1][2];
	}

											// $BE,9g>r7o$K4X$9$kItJ,(B($BN.NL(B)
	for (i = 0, k = 2 * n_seg; i < n_cnfl; i++, k++) {	
		for (j = 0; j < cnfl[i].nodesum; j++) {
			l = cnfl[i].segnum[j];
			for (m = 0; m < n_seg; m++) {
				if (abs(l) == seg[m].Re_segnum()) break;
			}
			if (l > 0) {				// $B$=$N%N!<%I$KN.F~$9$k;~(B
				M_node[k][4 * m + 2] = 1.;
				F_node[k] = F_node[k]
					- seg[m].Re_node_variable(LOWER, DISCHARGE, NEXT);
			}
			else if (l < 0) {			// $B$=$N%N!<%I$+$iN.=P$9$k;~(B
				M_node[k][4 * m] = - 1.;
				F_node[k] = F_node[k]
					+ seg[m].Re_node_variable(UPPER, DISCHARGE, NEXT);
			}
		}
	}

	k = 2 * n_seg + n_cnfl;
											// $BE,9g>r7o$K4X$9$kItJ,(B($B?e?<(B)
	for (i = 0; i < n_cnfl; i++) {		
		l = cnfl[i].segnum[0];
		for (m = 0; m < n_seg; m++) {
			if (abs(l) == seg[m].Re_segnum()) break;
		}
		if (l > 0) {
			for (j = 1; j < cnfl[i].nodesum; j++) {
				M_node[k][4 * m + 3] = 1.;
				F_node[k] = - seg[m].Re_node_variable(LOWER, DEPTH,
													  NEXT);
				ll = cnfl[i].segnum[j];
				for (mm = 0; mm < n_seg; mm++) {
					if (abs(ll) == seg[mm].Re_segnum()) break;
				}
				if (ll > 0) {
					M_node[k][4 * mm + 3] = - 1.;
					F_node[k] = F_node[k] +
						seg[mm].Re_node_variable(LOWER, DEPTH, NEXT);
					k++;
				}
				else if (ll < 0) {
					M_node[k][4 * mm + 3] = - 1.;
					F_node[k] = F_node[k] +
						seg[mm].Re_node_variable(UPPER, DEPTH, NEXT);
					k++;
				}
			}
		}
		else if (l < 0) {
			for (j = 1; j < cnfl[i].nodesum; j++) {
				M_node[k][4 * m + 1] = 1.;
				F_node[k] = - seg[m].Re_node_variable(UPPER, DEPTH,
													  NEXT);
				ll = cnfl[i].segnum[j];
				for (mm = 0; mm < n_seg; mm++) {
					if (abs(ll) == seg[mm].Re_segnum()) break;
				}
				if (ll > 0) {
					M_node[k][4 * mm + 3] = - 1.;
					F_node[k] = F_node[k] +
						seg[mm].Re_node_variable(LOWER, DEPTH, NEXT);
					k++;
				}
				else if(ll < 0) {
					M_node[k][4 * mm + 1] = - 1.;
					F_node[k] = F_node[k] +
						seg[mm].Re_node_variable(UPPER, DEPTH, NEXT);
					k++;
				}
			}
		}
	}

	for (i = 0; i < 2; i++) {
		delete [] c[i];
	}
	delete [] c;

	if (k != 4 * n_seg - n_tan) return NO;

//	printf("M_node\n");
//	for (i = 0; i < 4 * n_seg - n_tan; i++) {
//		for (j = 0; j < n_seg; j++) {
//			printf("%f %f %f %f | ", M_node[i][4 * j], 
//				   M_node[i][4 * j + 1], M_node[i][4 * j + 2],
//				   M_node[i][4 * j + 3]);
//		}
//		printf("\n%f\n", F_node[i]);
//	}
//	printf("\n");

	return YES;
}

Boolean BasinCellNR::Sweep_equation(double**& M, Vdary& F)
{
	// $B9gN.ItJ,$NA]$-=P$7$r9T$J$&(B

	int i, j, k, l, t;
	double d, v;
	Boolean flag = NO;

	for (i = 0; i < n_change; i++) {			// $B9TNs$NJB$SJQ$((B
		j = v_array[i][0];
		k = v_array[i][1];
		for (l = 0; l < 2; l++) {		// $BL$CNNL$N8r49(B
			t = d_node[2 * j][l];
			d_node[2 * j][l] = d_node[2 * k][l];
			d_node[2 * k][l] = t;
			t = d_node[2 * j + 1][l];
			d_node[2 * j + 1][l] = d_node[2 * k + 1][l];
			d_node[2 * k + 1][l] = t;
		}
		for (l = 0; l < n_seg * 4 - n_tan; l++) {
			v = M_node[l][2 * j];		// $BNs$N8r49(B
			M_node[l][2 * j] = M_node[l][2 * k];
			M_node[l][2 * k] = v;
			v = M_node[l][2 * j + 1];
			M_node[l][2 * j + 1] = M_node[l][2 * k + 1];
			M_node[l][2 * k + 1] = v;
		}
	}

	// $B%T%\%C%HA*Br(B

	for (i = n_seg * 4 - 1; i > n_tan * 2 - 1; i--) {
		if (M_node[i - n_tan][i] == 0.) {	// $B%T%\%C%H$,(B 0 $B$N;~(B
			flag = NO;
			for (j = n_tan * 2; j < n_seg * 4; j++) {
				if (M_node[i - n_tan][j] != 0.) {
					flag = YES; break;
				}
			}
			if (flag == YES) {			// $BNs$r8r49$9$kAj<j$,8+$D$+$C$?;~(B
				for (k = 0; k < n_seg * 4 - n_tan; k++) {
					d = M_node[k][i];	// $BNs$N8r49(B
					M_node[k][i] = M_node[k][j];
					M_node[k][j] = d;
				}
				for (k = 0; k < 2; k++) {
					t = d_node[i][k];	// $BL$CNNL$N8r49(B
					d_node[i][k] = d_node[j][k];
					d_node[j][k] = t;
				}
			}
			else {						// $BNs$N8r49$,$G$-$J$+$C$?;~(B
				for (j = 0; j < i - n_tan; j++) {
					if (M_node[j][i] != 0.) {
						flag = YES; break;
					}
				}
				if (flag == YES) {		// $B9T$r8r49$9$kAj<j$,8+$D$+$C$?;~(B
					for (k = 0; k < n_seg * 4; k++) {
						d = M_node[i - n_tan][k];	// $B9T$N8r49(B
						M_node[i - n_tan][k] = M_node[j][k];
						M_node[j][k] = d;
					}
					d = F_node[i - n_tan];			// $B2r$N8r49(B
					F_node[i - n_tan] = F_node[j];
					F_node[j] = d;
				}
				else return NO;				// $B9T$N8r49$b$G$-$J$+$C$?;~(B
			}
		}

		// $BA]$-=P$77W;;(B

		for (j = 0; j < n_seg * 4; j++) {	
			if (j != i) {
				M_node[i - n_tan][j] = M_node[i - n_tan][j] 
					/ M_node[i - n_tan][i];
			}
		}
		F_node[i - n_tan] = F_node[i - n_tan] / M_node[i - n_tan][i];
		M_node[i - n_tan][i] = 1.;

		for (j = 0; j < 4 * n_seg - n_tan; j++) {
			if (j != i - n_tan) {
				if (M_node[j][i] != 0.) {
					F_node[j] = F_node[j] - F_node[i - n_tan] *
						M_node[j][i];
					for (k = 0; k < n_seg * 4; k++) {
						if (k != i) {
							M_node[j][k] = M_node[j][k] 
								- M_node[i - n_tan][k] * M_node[j][i];
						}
					}
					M_node[j][i] = 0.;
				}
			}
		}
	}

	for (i = 0; i < n_tan; i++) {
		for (j = 0; j < n_tan * 2; j++) {
			M[i][j] = M_node[i][j];
		}
		F[i] = F_node[i];
	}

//	printf("Sweep\n");
//	for (i = 0; i < n_tan; i++) {
//		for (j = 0; j < 2 * n_tan; j++) {
//			printf("%f ", M[i][j]);
//		}
//		printf("\n%f\n", F[i]);
//	}
//	printf("\n");

	return YES;
}

void BasinCellNR::Re_ur(Viary& ur)
{
	int i, j, k = 0;

	ur.Resize(n_ur);

	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute == 2) {		// $B>eN.C<6-3&$N;~(B
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Upnode(nt[i].nodenumber) == YES) break;
			}
			ur[k] = seg[j].Re_segnum();
			k++;
		}
	}
	if (k != n_ur) {
		printf("Cannot return segment number of upper reach.\n");
		printf("BasinCellNR::Re_ur\n");
		exit(1);
	}
}

void BasinCellNR::Re_lr1(Viary& lr1)
{
	int i, j, k = 0;

	lr1.Resize(n_lr1);

	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute == 3) {		// $B2<N.C<6-3&(B 1 $B$N;~(B
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Lownode(nt[i].nodenumber) == YES) break;
			}
			lr1[k] = seg[j].Re_segnum();
			k++;
		}
	}
	if (k != n_lr1) {
		printf("Cannot return segment number of lower reach 1.\n");
		printf("BasinCellNR::Re_lr1\n");
		exit(1);
	}
}

void BasinCellNR::Re_lr2(Viary& lr2)
{
	int i, j, k = 0;

	lr2.Resize(n_lr2);

	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute == 4) {		// $B2<N.C<6-3&(B 2 $B$N;~(B
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Lownode(nt[i].nodenumber) == YES) break;
			}
			lr2[k] = seg[j].Re_segnum();
			k++;
		}
	}
	if (k != n_lr2) {
		printf("Cannot return segment number of lower reach 2.\n");
		printf("BasinCellNR::Re_lr2\n");
		exit(1);
	}
}

double BasinCellNR::Re_variable(int sn, ULFlag ul, QHFlag qh)
{
	int i;

	for (i = 0; i < n_seg; i++) {
		if (sn == seg[i].Re_segnum()) {
			return seg[i].Re_node_variable(ul, qh, NEXT);
		}
	}

	printf("Cannot return variable.\n");
	printf("BasinCellNR::Re_variable\n");
	exit(1);
}

int BasinCellNR::Re_position_of_variable(int sn, ULFlag ur, QHFlag qh)
{
	int i;

	for (i = 0; i < n_seg; i++) {
		if (pv[i].segnum == sn) break;
	}
	if (ur == UPPER) {
		if (qh == DISCHARGE) {
			return pv[i].upposition;
		}
		else if (qh == DEPTH) {
			return pv[i].upposition + 1;
		}
	}
	else if (ur == LOWER) {
		if (qh == DISCHARGE) {
			return pv[i].lowposition;
		}
		else if (qh == DEPTH) {
			return pv[i].lowposition + 1;
		}
	}

	printf("Inavalid parameter.\n");
	printf("BasinCellNR::Re_position_of_variable\n");
	exit(1);
}

void BasinCellNR::Renewal(Vdary v_cn)
{
	// $B7W;;C<E@$G$NL$CNNL$+$i3F%N!<%I$G$NL$CNNL$r7W;;$7!"3F2OF;$KEO$9(B

	int i, j, k;
	Vdary v_node;
	double** data;
	double sum;

	v_node.Resize(n_seg * 4);

	data = new double*[n_seg];
	for (i = 0; i < n_seg; i++) {
		data[i] = new double[2];
	}

	for (i = 0; i < 2 * n_tan; i++) {
		v_node[i] = v_cn[i];
	}

	// $B8e?JBeF~(B

	k = 2 * n_tan;
	for (i = n_tan; i < 4 * n_seg - n_tan; i++) {	
		sum = 0.;
		for (j = 0; j < 2 * n_tan; j++) {
			sum = sum + M_node[i][j] * v_node[j];
		}
		v_node[k] = F_node[i] - sum;
		k++;
	}

	for (i = 0; i < n_seg * 4; i++) {
		if (d_node[i][1] == 0) {		// $B>eN.C<N.NL(B
			for (j = 0; j < n_seg; j++) {
				if (d_node[i][0] == seg[j].Re_segnum()) break;
			}
			data[j][0] = v_node[i];
		}
		else if (d_node[i][1] == 1) {	// $B>eN.C<?e?<(B
			for (j = 0; j < n_seg; j++) {
				if (d_node[i][0] == seg[j].Re_segnum()) break;
			}
			data[j][1] = v_node[i];
		}
	}

	for (i = 0; i < n_seg; i++) {
		seg[i].Renewal(data[i]);
	}

	for (i = 0; i < n_seg; i++) {
		delete [] data[i];
	}
	delete [] data;
}

void BasinCellNR::Reset_variable(void)
{
	int i;

	for (i = 0; i < n_seg; i++) {
		seg[i].Reset_variable();
	}
}

Boolean BasinCellNR::Output_variable(Vdary*& Qall, Vdary*& Hall, CNFlag s)
{
	int i, j;

	if (s != CURRENT && s != NEXT) return NO;

	for (i = 0; i < n_seg; i++) {
		j = seg[i].Re_num_of_cs();
		Qall[i].Resize(j);
		Hall[i].Resize(j);

		if (seg[i].Output_variable(Qall[i], Hall[i], s) == NO) {
			return NO;
		}
	}
	return YES;
}

int BasinCellNR::Re_sum_of_cs(void)
{
	int i, sum = 0;
	for (i = 0; i < n_seg; i++) {
		sum = sum + seg[i].Re_num_of_cs();
	}
	return sum;
}

void BasinCellNR::Re_num_of_bp(Viary& sn_up, Viary& sn_low)
{
	int i, j, k, l, sum_up, sum_low;

	sum_up = 0; sum_low = 0;
	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute == 1) {
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Upnode(nt[i].nodenumber) == YES) {
					sum_up++; break;
				}
				else if (seg[j].Lownode(nt[i].nodenumber) == YES) {
					sum_low++; break;
				}
			}
		}
	}

	sn_up.Resize(sum_up);
	sn_low.Resize(sum_low);

	k = 0; l = 0;

	for (i = 0; i < n_node; i++) {
		if (nt[i].attribute == 1) {
			for (j = 0; j < n_seg; j++) {
				if (seg[j].Upnode(nt[i].nodenumber) == YES) {
					sn_up[k] = seg[j].Re_segnum();
					k++; break;
				}
				else if (seg[j].Lownode(nt[i].nodenumber) == YES) {
					sn_low[l] = seg[j].Re_segnum();
					l++; break;
				}
			}
		}
	}
}

Boolean BasinCellNR::Calc_discharge(Viary sn, Vdary q)
{
	int i, j, k, l;
	Viary up, low;
	Viary* sup;			// $BJ,9gN.E@$KBP$7$F>eN.B&$N2OF;6hJ,HV9f$r5-21(B
						// $B$9$kG[Ns(B
	Viary* slow;		// $BJ,9gN.E@$KBP$7$F2<N.B&$N2OF;6hJ,HV9f$r5-21(B
						// $B$9$kG[Ns(B
	double qup, qlow;	// $B>eN.B&$N2OF;$NN.NL$NAmOB!&2<N.B&$NN.NL(B
	Vdary b_io;			// $B2<N.B&$N2OF;$N(B b * sqrt(io)
	Boolean flag, all_flag;

	i = sn.Size();
	for (j = 0; j < i; j++) {
		flag = NO;
		for (k = 0; k < n_seg; k++) {
			if (seg[k].Re_segnum() == sn[j]) {
				flag = YES; break;
			}
		}
		if (flag == NO) return NO;
		seg[k].Calc_discharge(q[j]);
	}

	sup = new Viary[n_cnfl];
	slow = new Viary[n_cnfl];
	up.Resize(n_cnfl);
	low.Resize(n_cnfl);

	for (i = 0; i < n_cnfl; i++) {
		up[i] = 0;
		low[i] = 0;
		for (j = 0; j < cnfl[i].nodesum; j++) {
			if (cnfl[i].segnum[j] > 0) up[i]++;
			else if (cnfl[i].segnum[j] < 0) low[i]++;
		}
		sup[i].Resize(up[i]);
		slow[i].Resize(low[i]);
		k = 0;
		l = 0;
		for (j = 0; j < cnfl[i].nodesum; j++) {
			if (cnfl[i].segnum[j] > 0) {
				sup[i][k] = cnfl[i].segnum[j]; k++;
			}
			else if (cnfl[i].segnum[j] < 0) {
				slow[i][l] = - cnfl[i].segnum[j]; l++;
			}
		}
	}

	do {
		for (i = 0; i < n_cnfl; i++) {
			flag = YES;
			for (j = 0; j < up[i]; j++) {
				for (k = 0; k < n_seg; k++) {
					if (seg[k].Re_segnum() == sup[i][j]) break;
				}
				if (seg[k].Re_Qflag() != YES) flag = NO;
			}
			if (flag == YES) {
				qup = 0.;
				for (j = 0; j < up[i]; j++) {
					for (k = 0; k < n_seg; k++) {
						if (seg[k].Re_segnum() == sup[i][j]) break;
					}
					qup = qup + seg[k].Re_q();
				}

				b_io.Resize(low[i]);
				double sum = 0.;
				for (j = 0; j < low[i]; j++) {
					for (k = 0; k < n_seg; k++) {
						if (seg[k].Re_segnum() == slow[i][j]) {
							b_io[j] = seg[k].Re_b_and_io();
							sum = sum + b_io[j]; break;
						}
					}
				}
				for (j = 0; j < low[i]; j++) {
					qlow = qup * b_io[j] / sum;
					for (k = 0; k < n_seg; k++) {
						if (seg[k].Re_segnum() == slow[i][j]) {
							seg[k].Calc_discharge(qlow); break;
						}
					}
				}
			}
		}
		all_flag = YES;
		for (i = 0; i < n_seg; i++) {
			if (seg[i].Re_Qflag() == NO) {
				all_flag = NO; break;
			}
		}
	} while(all_flag == NO);

	delete [] sup;
	delete [] slow;

	Qflag = YES;
	return YES;
}
						
Boolean BasinCellNR::Calc_depth(Viary sn, Vdary h)
{
	int i, j, k, l;
	double d;
	Viary up, low;		// $BJ,9gN.E@$KBP$7$F>e2<N.B&$N2OF;6hJ,$N?t$r5-21(B
						// $B$9$kG[Ns(B
	Viary* sup;			// $BJ,9gN.E@$KBP$7$F>eN.B&$N2OF;6hJ,HV9f$r5-21(B
						// $B$9$kG[Ns(B
	Viary* slow;		// $BJ,9gN.E@$KBP$7$F2<N.B&$N2OF;6hJ,HV9f$r5-21(B
						// $B$9$kG[Ns(B
	double h_ave;		// $B2<N.B&$N2OF;$N?e?<$NJ?6Q(B
	Boolean flag, all_flag;

	i = sn.Size();
	for (j = 0; j < i; j++) {
		flag = NO;
		for (k = 0; k < n_seg; k++) {
			if (seg[k].Re_segnum() == sn[j]) {
				flag = YES; break;
			}
		}
		if (flag == NO) return NO;
		if (seg[k].Calc_depth(h[j], NO) == NO) return NO;
	}

	if ((n_lr1 + n_lr2) != 0) {
		for (i = 0; i < n_node; i++) {
			if (nt[i].attribute == 3 || nt[i].attribute == 4) {
				for (j = 0; j < n_seg; j++) {
					if (seg[j].Re_lownode() == nt[i].nodenumber) break;
				}
				if (seg[j].Calc_depth(0., YES) == NO) return NO;
			}
		}
	}

	sup = new Viary[n_cnfl];
	slow = new Viary[n_cnfl];
	up.Resize(n_cnfl);
	low.Resize(n_cnfl);

	for (i = 0; i < n_cnfl; i++) {
		up[i] = 0;
		low[i] = 0;
		for (j = 0; j < cnfl[i].nodesum; j++) {
			if (cnfl[i].segnum[j] > 0) up[i]++;
			else if (cnfl[i].segnum[j] < 0) low[i]++;
		}
		sup[i].Resize(up[i]);
		slow[i].Resize(low[i]);
		k = 0;
		l = 0;
		for (j = 0; j < cnfl[i].nodesum; j++) {
			if (cnfl[i].segnum[j] > 0) {
				sup[i][k] = cnfl[i].segnum[j]; k++;
			}
			else if (cnfl[i].segnum[j] < 0) {
				slow[i][l] = - cnfl[i].segnum[j]; l++;
			}
		}
	}

	do {
		for (i = 0; i < n_cnfl; i++) {
			flag = YES;
			for (j = 0; j < low[i]; j++) {
				for (k = 0; k < n_seg; k++) {
					if (seg[k].Re_segnum() == slow[i][j]) break;
				}
				if (seg[k].Re_Hflag() != YES) flag = NO;
			}
			if (flag == YES) {
				double sum = 0.;
				for (j = 0; j < low[i]; j++) {
					for (k = 0; k < n_seg; k++) {
						if (seg[k].Re_segnum() == slow[i][j]) break;
					}
					d = seg[k].Re_h();
					sum = sum + d;
					if (low[i] > 1) {
						printf("The one of height at the confluence\n");
						printf("is %f\n", d);
					}
				}

				h_ave = sum / low[i];
				if (low[i] > 1) {
					printf("The average of heiget at the confluence\n");
					printf("is %f\n", h_ave);
				}

				for (j = 0; j < up[i]; j++) {
					for (k = 0; k < n_seg; k++) {
						if (seg[k].Re_segnum() == sup[i][j]) break;
					}
					if (seg[k].Calc_depth(h_ave, NO) == NO) {
						return NO;
					}
				}
			}
		}
		all_flag = YES;
		for (i = 0; i < n_seg; i++) {
			if (seg[i].Re_Hflag() == NO) {
				all_flag = NO; break;
			}
		}
	} while(all_flag == NO);

	delete [] sup;
	delete [] slow;

	Hflag = YES;
	return YES;
}
						
Boolean BasinCellNR::Re_q(int sn, double& q)
{
	int i;
	double d;
	Boolean flag = NO;

	for (i = 0; i < n_seg; i++) {
		if (seg[i].Re_segnum() == sn) {
			flag = YES; break;
		}
	}
	if (flag == NO) {
		printf("Cannot return discharge\n");
		printf("BasinCellNR::Re_q\n");
		exit(1);
	}
	if (seg[i].Re_q(d) == YES) {
		q = d;
		return YES;
	}
	else return NO;
}

Boolean BasinCellNR::Re_h(int sn, double& h)
{
	int i;
	double d;
	Boolean flag = NO;

	for (i = 0; i < n_seg; i++) {
		if (seg[i].Re_segnum() == sn) {
			flag = YES; break;
		}
	}
	if (flag == NO) {
		printf("Cannot return depty\n");
		printf("BasinCellNR::Re_h\n");
		exit(1);
	}
	if (seg[i].Re_h(d) == YES) {
		h = d;
		return YES;
	}
	else return NO;
}

Boolean BasinCellNR::Re_Qflag(void)
{
	for (int i = 0; i < n_seg; i++) {
		if (seg[i].Re_Qflag() == NO)
			return NO;
	}
	return YES;
}

Boolean BasinCellNR::Re_Hflag(void)
{
	for (int i = 0; i < n_seg; i++) {
		if (seg[i].Re_Hflag() == NO)
			return NO;
	}
	return YES;
}

BasinCellNR::~BasinCellNR(void)
{
	int i;

	delete [] seg;
	delete [] nt;
	delete [] cnfl;
	delete [] pv;

	for (i = 0; i < n_change; i++) {
		delete [] v_array[i];
	}
	for (i = 0; i < n_seg * 4 - n_tan; i++){
		delete [] M_node[i];
	}
	for (i = 0; i < n_seg * 4; i++) {
		delete [] d_node[i];
	}
	delete [] v_array;
	delete [] M_node;
	delete [] d_node;
}
