//	t_fd.cc		Test simulation of class "FldDyna"

#include <stdio.h>
#include <time.h>		// time_t $B7?$NDj5A(B

#include "total.h"		// $B%/%i%9(B Total_system $B$NDj5A(B
#include "p_tmp.h"
#include "fld_dyna.h"	// $B%/%i%9(B FldDyna $B$NDj5A(B
#include "fld_slope.h"	// $B%/%i%9(B FldSlope $B$NDj5A(B

class TestFldDyna : public Total_system {

//	$BF~NOC<;R(B

  protected:
	I_file<double> ip;
	void Register_input_ports(void) {
		Register((void*) &ip);
	}

//	$B=PNOC<;R(B

  protected:
	O_file<double> op_low;
	O_file<Vdary> op_q0, op_h0, op_q1, op_h1, op_q2, op_h2,
	op_q3, op_h3, op_q4, op_h4;
	void Register_output_ports(void)
	{
		Register((void*) &op_low);
		Register((void*) &op_q0);
		Register((void*) &op_h0);
		Register((void*) &op_q1);
		Register((void*) &op_h1);
		Register((void*) &op_q2);
		Register((void*) &op_h2);
		Register((void*) &op_q3);
		Register((void*) &op_h3);
		Register((void*) &op_q4);
		Register((void*) &op_h4);
	}

//	$B9=@.%*%V%8%'%/%H(B

  protected:
	FldDyna fd;
	FldSlope fs;

	void Register_components(void) {
		Register((void*) &fd);
		Register((void*) &fs);
	}

//	$BFbIt$N@\B3(B

  protected:
	void Connect_ports(void)
	{
		int i;
		for (i = 0; i < 16; i++) {
			Connect(((void*) &ip), ((void*) &fd), "Receive", "rp_up",
					i);
		}
		Connect(((void*) &fd), "Send", "sp", 0, ((void*) &op_low));
		Connect(((void*) &fd), "Send", "sp_q", 0, ((void*) &op_q0));
		Connect(((void*) &fd), "Send", "sp_h", 0, ((void*) &op_h0));
		Connect(((void*) &fd), "Send", "sp_q", 1, ((void*) &op_q1));
		Connect(((void*) &fd), "Send", "sp_h", 1, ((void*) &op_h1));
		Connect(((void*) &fd), "Send", "sp_q", 2, ((void*) &op_q2));
		Connect(((void*) &fd), "Send", "sp_h", 2, ((void*) &op_h2));
		Connect(((void*) &fd), "Send", "sp_q", 3, ((void*) &op_q3));
		Connect(((void*) &fd), "Send", "sp_h", 3, ((void*) &op_h3));
		Connect(((void*) &fd), "Send", "sp_q", 4, ((void*) &op_q4));
		Connect(((void*) &fd), "Send", "sp_h", 4, ((void*) &op_h4));
	}

//	$BD>@\DL?.(B

	void Connect_components(void)
	{
		fd.Register((void*) &fs, 0);
		fs.Register((void*) &fd, 0);
	}

//	$BH?I|7W;;(B

	void Register_iterators(void) {}

//	$B=i4|>uBVNL$N@_Dj(B

  public:
	virtual void Set_initial_state(FILE* fp) {
		fscanf(fp, "%ld", &current_time);
	}

//	 $B%3%s%9%H%i%/%?(B

  public:
	TestFldDyna(void);

};

TestFldDyna::TestFldDyna(void)
	:	Total_system(),
		ip("t_fd.ip.const"),
		op_low("t_fd.op.low"),
		op_q0("t_fd.op.q0"),
		op_h0("t_fd.op.h0"),
		op_q1("t_fd.op.q1"),
		op_h1("t_fd.op.h1"),
		op_q2("t_fd.op.q2"),
		op_h2("t_fd.op.h2"),
		op_q3("t_fd.op.q3"),
		op_h3("t_fd.op.h3"),
		op_q4("t_fd.op.q4"),
		op_h4("t_fd.op.h4")
{
	int sim; SwitchFlag sf;
	printf("\n# Select simulation type 1 or 2.\n");
	printf("# 1. Simulate varied flow\n");
	printf("# 2. Simulate flood runoff\n");
	printf("# Which ? : ");
	scanf("%d", &sim);
	if (sim == 1) sf = VARIED;
	else if (sim == 2) sf = RUNOFF;
	else {
		fprintf(stderr, "# Select 1 or 2. Do it again.\n");
		exit(1);
	}

	fd.Init("fd", 0, 5, 6, "t_fd.ip.grid", "t_fd.ip.all",
			"t_fd.ip.cell", sf);
	fs.Init("fs", 0, 5, 6, "t_fd.ip.slope82");
//	fs.Init("fs", 0, 5, 6, "t_fd.ip.slope.const");

	class_name = "TestFldDyna";

	Init("total_system", 0, 0);
		// $BBh0l0z?t(B : object_name
		// $BBhFs0z?t(B : object_number
		// $BBh;00z?t(B : $BH?I|7W;;MWAG72$N?t(B
}

//	 $B%a%$%s%W%m%0%i%`(B

int main(void)
{
	TestFldDyna total_system;			// $BA4BN7O%b%G%k(B

	total_system.Set_ohymos_option();	// simulation option $B$N@_Dj(B

	if (total_system.Construct() != YES)
		{ printf("\n# Failure : Construct.\n"); return 1; }

		if (total_system.Switch() != YES)
		{ printf("\n# Failure : Switch.\n"); return 1; }
	
	if (total_system.Are_you_ready() != YES)
		{ printf("\n# Failure : Are_you_ready.\n"); return 1; }

	// $B%Q%i%a%?%U%!%$%k$+$iFI$_$H$j(B
	total_system.Read_parameter_file("t_fd.pmt");
	printf("Parameter OK\n");

	// $B=i4|>uBV$r%U%!%$%k$+$iFI$_$H$j(B
	total_system.Read_initial_state_file("t_fd.ist");
//	total_system.Read_initial_state_file("t_fd.ist.const");
	printf("Initial_state_file OK\n");

	// $BAw?.C<;R%G!<%?$r%j%9%H%"(B
	total_system.Read_send_port_file("t_fd.isd");
	printf("Send_port_file OK\n");

	total_system.Initial_work();
	printf("Initial_work OK\n");
	total_system.Work();
	printf("Work OK\n");

	// $B:G=*>uBV$r%U%!%$%k$KJ]B8(B
	total_system.Write_terminal_state("t_fd.tst");
	printf("Terminal_state OK\n");

	// $BAw?.C<;R$K;D$C$F$$$k%G!<%?$r%U%!%$%k$KJ]B8(B
	total_system.Write_send_port_stock("t_fd.tsd");
	printf("Send_port_stock OK\n");
	return 0;
}
