// fldSlope.cc

//----------------------------------------------------------------------
//	FldSlope		$B<PLL%b%G%k(B(FldDyna $BMQ(B)
//----------------------------------------------------------------------

#include "fldSlope.h"	// $B%/%i%9(B FldSlope $B$NDj5A(B

Boolean FldSlope::Init(char* o_name, int o_num, size_t num_row, size_t
					   num_col, char* f_name)
{
	int i;
	double d;
	Vdary data;
	time_t t;
	char str[16384];
	char* pstr;
	FILE* fp;

	if ((int)num_row < 0 || (int)num_col < 0) {
		Eprint(__FILE__, __LINE__);
		// Invalid inputs. (num_row < 0 || num_col < 0)
		// FldSlope::Init
		Oprint(); exit(1);
	}

	n_row = num_row;
	n_col = num_col;
	n_cell = n_row * n_col;

	slist.Init(Clf_vdary);

	data.Resize(n_cell);

	if ((fp = fopen(f_name, "r")) == NULL) {
		Eprint(__FILE__, __LINE__);
		// Cannot open file.
		// FldSlope::Init
		Oprint(); exit(1);
	}

	while (fgets(str, 16384, fp) != NULL) {
		pstr = str;
		while (*pstr == ' ' || *pstr == '\t') pstr++;
		if (sscanf(pstr, "%ld", &t) != 1) {
			Eprint(__FILE__, __LINE__);
			// Invalid inputs.
			// FldSlope::Init
			Oprint(); exit(1);
		}
		if (t < 0) {
			Eprint(__FILE__, __LINE__);
			// Invalid inputs.
			// FldSlope::Init
			Oprint(); exit(1);
		}
		while (*pstr != ' ' && *pstr != '\t') pstr++;
		for (i = 0; i < (int)n_cell; i++) {
			while (*pstr == ' ' || *pstr == '\t') pstr++;
			if (sscanf(pstr, "%lf", &d) != 1) {
				Eprint(__FILE__, __LINE__);
				// Invalid inputs.
				// FldSlope::Init
				Oprint(); exit(1);
			}
			data[i] = d;
			while (*pstr != ' ' && *pstr != '\t') pstr++;
		}
		p = new Data<Vdary>;
		p->Set_data(t, data);
		slist.Put_tail((void*) p);
	}

	return Element::Init(o_name, o_num, 1, NULL);
}

FldSlope::FldSlope(char* o_name, int o_num, size_t num_row, size_t
				   num_col, char* f_name)
	: Element()
{
	class_name = "FldSlope";
	Init(o_name, o_num, num_row, num_col, f_name);
}

FldSlope::FldSlope(void)
	: Element()
{
	class_name = "FldSlope";
}

Boolean FldSlope::Re_lat(size_t row, size_t col, time_t ct, double& lat)
{
	void* buf;
	time_t t, pre_t;
	Vdary d(n_cell), pre_d(n_cell);
	size_t s;

//	if (row > n_row || col > n_col) return NO;		// $B9T!&Ns$,IT@5(B
//	if (row < 0 || col < 0) return NO;				// $B9T!&Ns$,IT@5(B

	s = n_col * row + col;

	slist.Top();
	if (slist.Look(buf) == YES) {
		((Data<Vdary>*) buf)->Get_data(pre_t, pre_d);
		if (ct < pre_t) return NO;					// ct $B$,IT@5(B
		if (ct == pre_t) {
			lat = pre_d[s]; return YES;
		}
	}
	else return NO;			// $B%G!<%?$,0l$D$b$J$$(B
	while (slist.Look(buf) == YES) {
		((Data<Vdary>*) buf)->Get_data(t, d);
		if (ct <= t) {
// 			// modified by Y.I (Fri Sep 26 20:10:44 1997)
// 			lat = pre_d[s] + (d[s] - pre_d[s]) * (double)((ct - pre_t) /
// 														  (t - pre_t));
			lat = pre_d[s] + (d[s] - pre_d[s]) * 
				(double)(ct - pre_t) / (double)(t - pre_t);

			return YES;
		}
		pre_t = t;
		pre_d = d;
	}

	lat = pre_d[s];
	printf("Warning!! Current_time is over the newest data of
		fldSlope.\n");

	return YES;

//	return NO;				// $B%G!<%?$,F@$i$l$J$+$C$?(B
}
