/*;  grid.h {\documentstyle{jsrc2latex}\font\tenrm=cmtt10} */

/*;  $$Revision: 1.3 $$ {\rhead{\sl grid.h\quad\thepage}} */
/*;  $$Date: 1996/12/05 10:11:12 $$  */
/*;  $$Source: /home/shiiba/96prog/matrix/grid.h,v $$  */

/*

Grid<Type>  Type ǤȤʻҷΥǡ¤ɽ饹Ǥ

㤨СGrid<Complex> a(2,3); ȡa(i,j), i=0, 1, j=0, 1, 2 
6Ĥ Complex ǤĳʻҷΥǡɽޤ

GenGrid<Type> ϡźɬ1ϤޤʤγʻҷΥǡ¤
ɽΥ饹ǤGrid<Type> ѾƺƤޤ

*/

#ifndef GRID_H
#define GRID_H

#include "common.h"
#include "stddef.h"
#include "limits.h"
#include "simple.h"
#include "string.h"
#include "error.h"

//-----------------------------------
// Grid
//      A two-dimensional array class
//-----------------------------------

template <class D>
class Grid
{
 public:
  // constructors
  Grid();
  
  Grid
  (
   size_t rows,
   size_t cols
   );
  
  Grid
  (
   const Grid<D> & m
   );
  
  // destructors
  ~Grid();
  
  // assignment operator
  void operator =
  (
   const Grid<D> & m
   );
  
  void operator =
  (
   const D * array
   );
  
  // interrogation
  size_t GetRows() const;
  size_t GetCols() const;
  
  Boolean IsVector() const;
  Boolean IsRowVector() const;
  Boolean IsColVector() const;
  Boolean IsSquare() const;
  
  // retrieve elements
  D Get
  (
   size_t row,
   size_t col
   ) const;
  
  D & operator () (
    size_t row,
    size_t col
    );
  
  // internal function w/o exception check!
  D & Elem
  (
   size_t row,
   size_t col
   ) const;
       
  // apply a function to each element
  void Apply(
    D (* func)(const D & n)
    );
  
 friend Grid<D> Apply(
   const Grid<D> & m,
   D (* func)(const D & n)
   );
  
  // fill matrix with specific value
  void Fill
  (
   const D & x
   );
  
  // create a row matrix
  Grid<D> VectorRow
  (
   size_t row
   );
  
  // create a column vector
  Grid<D> VectorCol
  (
   size_t col
   );
  
  // transpose a matrix
  Grid<D> Transpose();
  
  // change size (destroying contents)
  void Resize(
   size_t rows,
   size_t cols
   );
  
 protected:
  D * MmData;
  size_t R;
  size_t C;
  size_t N;
  
  size_t Index
  (
   size_t row,
   size_t col
   ) const;
  
};

template <class D>
inline size_t Grid<D>::Index(
 size_t row,
 size_t col
 ) const
{
  return (row * C + col);
}

// interrogation
template <class D>
inline size_t Grid<D>::GetRows() const
{
  return R;
}

template <class D>
inline size_t Grid<D>::GetCols() const
{
  return C;
}

template <class D>
inline Boolean Grid<D>::IsVector() const
{
  if ((R == 1) || (C == 1))
    return YES;
  else
    return NO;
}

template <class D>
inline Boolean Grid<D>::IsRowVector() const
{
  if (C == 1)
    return YES;
  else
    return NO;
}

template <class D>
inline Boolean Grid<D>::IsColVector() const
{
  if (R == 1)
    return YES;
  else
    return NO;
}

template <class D>
inline Boolean Grid<D>::IsSquare() const
{
  if (R == C)
    return YES;
  else
    return NO;
}

template <class D>
inline D & Grid<D>::Elem
(
 size_t row,
 size_t col
 )
     const
{
  return MmData[row * C + col];
}

template <class D>
class GenGrid : public Grid<D>
{
  // źϰϤˤĤư̲줿åɡ
  // źβ¤Ǥޤ
  // GenGrid<double> A(1,3, 1,4);
  // ϡ34ιǡź1Ϥޤޤ
  
 private:
  int Imin;
  int Jmin;
  
 public:
  GenGrid(		// 󥹥ȥ饯
    int IminVal,	// źβ
    int ImaxVal,	// źξ
    int JminVal,	// 裲źβ
    int JmaxVal		// 裲źξ
    )
    : Grid<D>(ImaxVal-IminVal+1, JmaxVal-JminVal+1)
  {
    Imin = IminVal; Jmin = JminVal;
  };
  
  GenGrid(		// ԡ󥹥ȥ饯
    const GenGrid<D>& a
    )
    : Grid<D>(a), Imin(a.Imin), Jmin(a.Jmin) { }
  
  GenGrid<D>& operator=( // 黻
    const GenGrid<D>& a
    )
  {
    if (this != &a)
      {
	Grid<D>::operator=(a);
	Imin = a.Imin;   Jmin = a.Jmin;
      }
    return *this;
  }
  
  D
  Get(			// Ǥͤ򵢤ؿ
    int rowVal,		// ֹ
    int colVal		// ֹ
    )
  {
    return MmData[Index(rowVal-Imin,colVal-Jmin)];
  }
  D&
  Elem(			// ǤλȤ򵢤ؿźʤ
    int rowVal,		// ֹ
    int colVal		// ֹ
    )
  {
    return MmData[(rowVal-Imin)*C+colVal-Jmin];
  }
  D&
  operator()(		// ǤλȤ򵢤źꡣ
    int rowVal,		// ֹ
    int colVal		// ֹ
    )
  {
    return MmData[Index(rowVal-Imin,colVal-Jmin)];
  }

  // źβ¤Ⱦ¤򶵤ؿ
  int GetRowmin() const { return Imin; }
  int GetColmin() const { return Jmin; }
  int GetRowmax() const { return Imin + R - 1; }
  int GetColmax() const { return Jmin + C - 1; }

  // ǥȥ饯
  ~GenGrid()
  {
    delete [] MmData;
  }
};

#endif

/*; end of file */
