// segmentNR.h

//---------------------------------------------------------------------
//	SegmentNR		$BC10l2OF;%/%i%9(B
//---------------------------------------------------------------------

#if !defined(_segmentNR_h)
#define _segmentNR_h

#include <stdio.h>
#include <time.h>
#include <math.h>

#include "vary.h"			// $B%/%i%9(B Vary $B$NDj5A(B
#include "p_tmp.h"
#include "fldstruct.h"

#define G	9.8				// $B=ENO2CB.EY(B
#define EPS 0.00001
typedef Vary<double> Vdary;

//	$B%/%i%9(B SegmentNR $B$NDj5A(B

class SegmentNR {

//	$B%Q%i%a%?(B

  protected:
	double L;		// $B2OF;D9(B
	Vdary b;		// $B2OF;I}(B (active)
	Vdary b0;		// $B2OF;I}(B (inactive)
	Vdary dx;		// $B6u4V4V3V(B
	double zup;		// $BI89b(B($B>eN.B&(B)
	double zlow;	// $BI89b(B($B2<N.B&(B)
	double io;		// $B2O>28{G[(B
	double man;		// $B%^%K%s%0$NAFEY78?t(B
	double theta;	// $B:9J,$N=E$_IU$1(B factor
	int n_cs;		// $B7W;;CGLL?t(B

	int segnum;		// $B2OF;6hJ,HV9f(B
	int upnode;		// $B>eN.B&$N%N!<%IHV9f(B
	int lownode;	// $B2<N.B&$N%N!<%IHV9f(B

	Boolean Qflag;	// $B7W;;=*N;H=DjMQ%U%i%0(B ($BN.NL(B)
					// $B=*$C$F$$$?$i(B YES ($BITEyN.7W;;MQ(B)
	Boolean Hflag;	// $B7W;;=*N;H=DjMQ%U%i%0(B ($B?e?<(B)
					// $B=*$C$F$$$?$i(B YES ($BITEyN.7W;;MQ(B)

	time_t start_t_step;	// $B7W;;3+;O;~$N%?%$%`%9%F%C%W(B

//	$B>uBVNL(B

  protected:
	Vdary Qn;		// next_time $B$G$NN.NL(B
	Vdary Hn;		// next_time $B$G$N?e?<(B
	Vdary Qc;		// $B8=:_$NN.NL(B
	Vdary Hc;		// $B8=:_$N?e0L(B
	double Qlatc;	// $BB&J}N.F~NL(B(current_time) $B5Z$S(B
					// $BITEyN.7W;;$N;~$NB&J}N.F~NL(B
	double Qlatn;	// $BB&J}N.F~NL(B(next_time)

	Vdary dq;		// $BN.NL$NJd@5NL(B (Newton-Raphson $BK!(B)
	Vdary dh;		// $B?e?<$NJd@5NL(B (Newton-Raphson $BK!(B)
	Vdary F;		// $B;D:9(B (Newton-Raphson $BK!(B)
	double** J;		// $B%d%3%S9TNs(B (2 * n_cs - 2 $B!_(B 4 $B$N9TNs(B)
	double** J_fixed;	// $B8GDjItJ,$r5-21$7$F$*$/9TNs(B

	Vdary An;	// next_time $B$G$NCGLL@Q(B (active)
	Vdary A0n;	// next_time $B$G$NCGLL@Q(B (inactive)
	Vdary Ifn;	// next_time $B$G$NK`;$8{G[(B

	Vdary Ac;	// $B8=:_$NCGLL@Q(B (active)
	Vdary A0c;	// $B8=:_$NCGLL@Q(B (inactive)
	Vdary Ifc;	// $B8=:_$NK`;$8{G[(B

//	$B=i4|2=4X?t!&%3%s%9%H%i%/%?!&%G%9%H%i%/%?(B

  public:
	Boolean Init(int snum, int unode, int lnode);
	SegmentNR(int snum, int unode, int lnode);
	SegmentNR(void) {}
	~SegmentNR(void);

//	$B%Q%i%a%?$N@_Dj!&>uBVNL$N=i4|2=!&:G=*>uBVNL$NJ]B8(B

  public:
	Boolean Set_parameter(FILE* fp, time_t time_step);
	void Set_init_for_varied(double qup, double qlat);
	// $BITEyN.$N7W;;$N$?$a$N=i4|>uBVNL$r@_Dj$7$^$9!#(B($B>eN.C<MQ(B)
	// qup : $B>eN.C<$G$NN.NL(B
	// qlat : $BC10LI}Ev$?$j$NB&J}N.F~NL(B
	void Set_init_for_varied(double qlat);
	// $BITEyN.$N7W;;$N$?$a$N=i4|>uBVNL$r@_Dj$7$^$9!#(B($B>eN.C<0J30MQ(B)
	// qlat : $BC10LI}Ev$?$j$NB&J}N.F~NL(B
	Boolean Set_init_for_runoff(FILE* fp, double lat);
	// $B=i4|>uBVNL$rA4$F$N7W;;CGLL$G@_Dj$7$^$9!#(B
	// lat : $BC10LI}Ev$?$j$NB&J}N.F~NL(B
	Boolean Save_terminal_state(FILE* fp);
	// $B:G=*>uBVNL$rJ]B8$7$^$9!#(B

// $B%/%i%9(B SegmentNR $B$KFCM-$N4X?t(B

	double Re_node_variable(ULFlag ul, QHFlag qh, CNFlag cn);
	// $B>e2<N.C<$NN.NL$H?e?<$rJV$7$^$9!#(B
	// ul : UPPER or LOWER
	// qh : DISCHARGE or DEPTH
	// cn : CURRENT or NEXT
	void First_estimation(double lat);
	// $B=i4|$N?dDjCM$r@_Dj$7$^$9!#(B($B3F%?%$%`%9%F%C%W$N7W;;3+;O;~$K8F$P$l$k(B)
	// lat : next_time $B$G$NB&J}N.F~NL(B
	void Set_upper_condition(double qup) { Qn[0] = qup; }
	// $B>eN.C<6-3&>r7o$r@_Dj$7$^$9!#(B
	// qup : $B>eN.C<6-3&$G$NN.NL(B
	void Set_lower_condition(double hlow);
	// $B2<N.C<6-3&>r7o$r@_Dj$7$^$9!#(B
	// hlow : $B2<N.C<6-3&$G$N?e0L(B
	Boolean Upnode(int unode);
	// unode == upnode $B$J$i$P(B YES $B$rJV$7$^$9!#(B
	Boolean Lownode(int lnode);
	// lnode == lownode $B$J$i$P(B YES $B$rJV$7$^$9!#(B

// $B7W;;5!G=(B

	// $BN.=P7W;;(B

	void Make_equation(time_t time_step);
	// $BO"N)J}Dx<0$r$?$F$^$9!#(B
	Boolean Sweep_equation(double**& c);
	// $BO"N)J}Dx<0$NA]$-=P$7$r9T$J$$$^$9!#(B
	// c : $BA]$-=P$78e$N9TNs(B
	void Renewal(double* data);
	// $B3FCGLL$G$N(B dq, dh $B$NCM$r7W;;$7!"(BQn, Hn $B$r99?7$7$^$9!#(B
	// data[2] : $B>eN.C<$G$N(B dq, dh
	void Reset_variable(void);
	// $B>uBVNL$r(B next_time $B$N$b$N$K99?7$7$^$9!#(B
	Boolean Output_variable(Vdary& Qall, Vdary& Hall, CNFlag s);
	// $B3F7W;;CGLL$NN.NL$H?e?<$rJV$7$^$9!#(B
	// s : CURRENT or NEXT

	// $BITEyN.7W;;(B

	void Calc_discharge(double qup);
	// $BN.NL$NJ,I[$r7W;;$7$^$9!#(B
	// qup : $B>eN.C<$NN.NL(B
	Boolean Calc_depth(double hlow, Boolean lowflag);
	// $B2<N.C<$N?e?<$rMQ$$$F3FCGLL$N?e?<$r7W;;$7$^$9!#(B
	// $B:G2<N.C<$N>l9g$O%^%K%s%0<0$rMQ$$$F3FCGLL$N?e?<$r7W;;$7$^$9!#(B
	// hlow : $B2<N.C<$N?e?<(B
	// lowflag : YES $B:G2<N.C<(B $B!&(B NO $B$=$l0J30(B
	Boolean Re_q(double& q);
	// $B7W;;$,=*N;$7$F$$$l$P2<N.C<$NN.NL$rJV$7$^$9!#(B
	Boolean Re_h(double& h);
	// $B7W;;$,=*N;$7$F$$$l$P>eN.C<$N?e?<$rJV$7$^$9!#(B
	double Re_b_and_io(void) { return b[0] * sqrt(io); }
	// $B>eN.C<$N(B b * sqrt(io) $B$rJV$7$^$9!#(B

// $B%$%s%i%$%s4X?t(B

	inline double Re_length(void) {	return L; }
	// $B2OF;D9(B L $B$rJV$7$^$9!#(B
	inline int Re_segnum(void) { return segnum; }
	// $B2OF;6hJ,HV9f$rJV$7$^$9!#(B
	inline int Re_upnode(void) { return upnode; }
	// $B>eN.B&%N!<%IHV9f$rJV$7$^$9!#(B
	inline int Re_lownode(void) { return lownode; }
	// $B2<N.B&%N!<%IHV9f$rJV$7$^$9!#(B
	inline int Re_num_of_cs(void) { return n_cs; }
	// $B7W;;CGLL?t$rJV$7$^$9!#(B
	inline double Re_q(void) { return Qc[n_cs - 1]; }
	// $B2<N.C<$NN.NL$rJV$7$^$9!#(B
	inline double Re_h(void) { return Hc[0]; }
	// $B>eN.C<$N?e?<$rJV$7$^$9!#(B
	inline Boolean Re_Qflag(void) { return Qflag; }
	// Qflag $B$rJV$7$^$9!#(B
	inline Boolean Re_Hflag(void) { return Hflag; }
	// Hflag $B$rJV$7$^$9!#(B
};

#endif //	! _segmentNR_h
